diff --git a/src/backend/access/transam/multixact.c b/src/backend/access/transam/multixact.c
new file mode 100644
index 1a7824b..a4b2c97
*** a/src/backend/access/transam/multixact.c
--- b/src/backend/access/transam/multixact.c
***************
*** 112,126 ****
  	((xid) / (MultiXactOffset) MULTIXACT_OFFSETS_PER_PAGE)
  #define MultiXactIdToOffsetEntry(xid) \
  	((xid) % (MultiXactOffset) MULTIXACT_OFFSETS_PER_PAGE)
! #define MultiXactIdToOffsetSegment(xid) (MultiXactIdToOffsetPage(xid) / SLRU_PAGES_PER_SEGMENT)
  
  /*
   * The situation for members is a bit more complex: we store one byte of
   * additional flag bits for each TransactionId.  To do this without getting
!  * into alignment issues, we store four bytes of flags, and then the
!  * corresponding 4 Xids.  Each such 5-word (20-byte) set we call a "group", and
!  * are stored as a whole in pages.  Thus, with 8kB BLCKSZ, we keep 409 groups
!  * per page.  This wastes 12 bytes per page, but that's OK -- simplicity (and
   * performance) trumps space efficiency here.
   *
   * Note that the "offset" macros work with byte offset, not array indexes, so
--- 112,126 ----
  	((xid) / (MultiXactOffset) MULTIXACT_OFFSETS_PER_PAGE)
  #define MultiXactIdToOffsetEntry(xid) \
  	((xid) % (MultiXactOffset) MULTIXACT_OFFSETS_PER_PAGE)
! #define MultiXactIdToOffsetSegment(xid) ((uint64)(MultiXactIdToOffsetPage(xid) / SLRU_PAGES_PER_SEGMENT))
  
  /*
   * The situation for members is a bit more complex: we store one byte of
   * additional flag bits for each TransactionId.  To do this without getting
!  * into alignment issues, we store eight bytes of flags, and then the
!  * corresponding 8 Xids.  Each such 9-word (72-byte) set we call a "group", and
!  * are stored as a whole in pages.  Thus, with 8kB BLCKSZ, we keep 113 groups
!  * per page.  This wastes 56 bytes per page, but that's OK -- simplicity (and
   * performance) trumps space efficiency here.
   *
   * Note that the "offset" macros work with byte offset, not array indexes, so
***************
*** 132,138 ****
  #define MXACT_MEMBER_XACT_BITMASK	((1 << MXACT_MEMBER_BITS_PER_XACT) - 1)
  
  /* how many full bytes of flags are there in a group? */
! #define MULTIXACT_FLAGBYTES_PER_GROUP		4
  #define MULTIXACT_MEMBERS_PER_MEMBERGROUP	\
  	(MULTIXACT_FLAGBYTES_PER_GROUP * MXACT_MEMBER_FLAGS_PER_BYTE)
  /* size in bytes of a complete group */
--- 132,138 ----
  #define MXACT_MEMBER_XACT_BITMASK	((1 << MXACT_MEMBER_BITS_PER_XACT) - 1)
  
  /* how many full bytes of flags are there in a group? */
! #define MULTIXACT_FLAGBYTES_PER_GROUP	 	8	
  #define MULTIXACT_MEMBERS_PER_MEMBERGROUP	\
  	(MULTIXACT_FLAGBYTES_PER_GROUP * MXACT_MEMBER_FLAGS_PER_BYTE)
  /* size in bytes of a complete group */
***************
*** 142,163 ****
  #define MULTIXACT_MEMBERS_PER_PAGE	\
  	(MULTIXACT_MEMBERGROUPS_PER_PAGE * MULTIXACT_MEMBERS_PER_MEMBERGROUP)
  
- /*
-  * Because the number of items per page is not a divisor of the last item
-  * number (member 0xFFFFFFFF), the last segment does not use the maximum number
-  * of pages, and moreover the last used page therein does not use the same
-  * number of items as previous pages.  (Another way to say it is that the
-  * 0xFFFFFFFF member is somewhere in the middle of the last page, so the page
-  * has some empty space after that item.)
-  *
-  * This constant is the number of members in the last page of the last segment.
-  */
- #define MAX_MEMBERS_IN_LAST_MEMBERS_PAGE \
- 		((uint32) ((0xFFFFFFFF % MULTIXACT_MEMBERS_PER_PAGE) + 1))
- 
  /* page in which a member is to be found */
  #define MXOffsetToMemberPage(xid) ((xid) / (TransactionId) MULTIXACT_MEMBERS_PER_PAGE)
! #define MXOffsetToMemberSegment(xid) (MXOffsetToMemberPage(xid) / SLRU_PAGES_PER_SEGMENT)
  
  /* Location (byte offset within page) of flag word for a given member */
  #define MXOffsetToFlagsOffset(xid) \
--- 142,150 ----
  #define MULTIXACT_MEMBERS_PER_PAGE	\
  	(MULTIXACT_MEMBERGROUPS_PER_PAGE * MULTIXACT_MEMBERS_PER_MEMBERGROUP)
  
  /* page in which a member is to be found */
  #define MXOffsetToMemberPage(xid) ((xid) / (TransactionId) MULTIXACT_MEMBERS_PER_PAGE)
! #define MXOffsetToMemberSegment(xid) ((uint64)(MXOffsetToMemberPage(xid) / SLRU_PAGES_PER_SEGMENT))
  
  /* Location (byte offset within page) of flag word for a given member */
  #define MXOffsetToFlagsOffset(xid) \
*************** typedef struct MultiXactStateData
*** 216,237 ****
  	MultiXactId oldestMultiXactId;
  	Oid			oldestMultiXactDB;
  
- 	/*
- 	 * Oldest multixact offset that is potentially referenced by a multixact
- 	 * referenced by a relation.  We don't always know this value, so there's
- 	 * a flag here to indicate whether or not we currently do.
- 	 */
- 	MultiXactOffset oldestOffset;
- 	bool		oldestOffsetKnown;
- 
  	/* support for anti-wraparound measures */
  	MultiXactId multiVacLimit;
- 	MultiXactId multiWarnLimit;
- 	MultiXactId multiStopLimit;
- 	MultiXactId multiWrapLimit;
- 
- 	/* support for members anti-wraparound measures */
- 	MultiXactOffset offsetStopLimit;	/* known if oldestOffsetKnown */
  
  	/*
  	 * Per-backend data starts here.  We have two arrays stored in the area
--- 203,210 ----
*************** static void mXactCachePut(MultiXactId mu
*** 353,371 ****
  static char *mxstatus_to_string(MultiXactStatus status);
  
  /* management of SLRU infrastructure */
! static int	ZeroMultiXactOffsetPage(int pageno, bool writeXlog);
! static int	ZeroMultiXactMemberPage(int pageno, bool writeXlog);
! static bool MultiXactOffsetPagePrecedes(int page1, int page2);
! static bool MultiXactMemberPagePrecedes(int page1, int page2);
! static bool MultiXactOffsetPrecedes(MultiXactOffset offset1,
! 						MultiXactOffset offset2);
  static void ExtendMultiXactOffset(MultiXactId multi);
  static void ExtendMultiXactMember(MultiXactOffset offset, int nmembers);
- static bool MultiXactOffsetWouldWrap(MultiXactOffset boundary,
- 						 MultiXactOffset start, uint32 distance);
- static bool SetOffsetVacuumLimit(bool is_startup);
  static bool find_multixact_start(MultiXactId multi, MultiXactOffset *result);
! static void WriteMZeroPageXlogRec(int pageno, uint8 info);
  static void WriteMTruncateXlogRec(Oid oldestMultiDB,
  					  MultiXactId startOff, MultiXactId endOff,
  					  MultiXactOffset startMemb, MultiXactOffset endMemb);
--- 326,337 ----
  static char *mxstatus_to_string(MultiXactStatus status);
  
  /* management of SLRU infrastructure */
! static int	ZeroMultiXactOffsetPage(int64 pageno, bool writeXlog);
! static int	ZeroMultiXactMemberPage(int64 pageno, bool writeXlog);
  static void ExtendMultiXactOffset(MultiXactId multi);
  static void ExtendMultiXactMember(MultiXactOffset offset, int nmembers);
  static bool find_multixact_start(MultiXactId multi, MultiXactOffset *result);
! static void WriteMZeroPageXlogRec(int64 pageno, uint8 info);
  static void WriteMTruncateXlogRec(Oid oldestMultiDB,
  					  MultiXactId startOff, MultiXactId endOff,
  					  MultiXactOffset startMemb, MultiXactOffset endMemb);
*************** MultiXactIdExpand(MultiXactId multi, Tra
*** 449,455 ****
  	/* MultiXactIdSetOldestMember() must have been called already. */
  	Assert(MultiXactIdIsValid(OldestMemberMXactId[MyBackendId]));
  
! 	debug_elog5(DEBUG2, "Expand: received multi %u, xid %u status %s",
  				multi, xid, mxstatus_to_string(status));
  
  	/*
--- 415,421 ----
  	/* MultiXactIdSetOldestMember() must have been called already. */
  	Assert(MultiXactIdIsValid(OldestMemberMXactId[MyBackendId]));
  
! 	debug_elog5(DEBUG2, "Expand: received multi " XID_FMT ", xid " XID_FMT " status %s",
  				multi, xid, mxstatus_to_string(status));
  
  	/*
*************** MultiXactIdExpand(MultiXactId multi, Tra
*** 474,480 ****
  		member.status = status;
  		newMulti = MultiXactIdCreateFromMembers(1, &member);
  
! 		debug_elog4(DEBUG2, "Expand: %u has no members, create singleton %u",
  					multi, newMulti);
  		return newMulti;
  	}
--- 440,446 ----
  		member.status = status;
  		newMulti = MultiXactIdCreateFromMembers(1, &member);
  
! 		debug_elog4(DEBUG2, "Expand: " XID_FMT " has no members, create singleton " XID_FMT,
  					multi, newMulti);
  		return newMulti;
  	}
*************** MultiXactIdExpand(MultiXactId multi, Tra
*** 488,494 ****
  		if (TransactionIdEquals(members[i].xid, xid) &&
  			(members[i].status == status))
  		{
! 			debug_elog4(DEBUG2, "Expand: %u is already a member of %u",
  						xid, multi);
  			pfree(members);
  			return multi;
--- 454,460 ----
  		if (TransactionIdEquals(members[i].xid, xid) &&
  			(members[i].status == status))
  		{
! 			debug_elog4(DEBUG2, "Expand: " XID_FMT " is already a member of " XID_FMT,
  						xid, multi);
  			pfree(members);
  			return multi;
*************** MultiXactIdExpand(MultiXactId multi, Tra
*** 529,535 ****
  	pfree(members);
  	pfree(newMembers);
  
! 	debug_elog3(DEBUG2, "Expand: returning new multi %u", newMulti);
  
  	return newMulti;
  }
--- 495,501 ----
  	pfree(members);
  	pfree(newMembers);
  
! 	debug_elog3(DEBUG2, "Expand: returning new multi " XID_FMT, newMulti);
  
  	return newMulti;
  }
*************** MultiXactIdIsRunning(MultiXactId multi, 
*** 552,558 ****
  	int			nmembers;
  	int			i;
  
! 	debug_elog3(DEBUG2, "IsRunning %u?", multi);
  
  	/*
  	 * "false" here means we assume our callers have checked that the given
--- 518,524 ----
  	int			nmembers;
  	int			i;
  
! 	debug_elog3(DEBUG2, "IsRunning " XID_FMT "?", multi);
  
  	/*
  	 * "false" here means we assume our callers have checked that the given
*************** MultiXactIdIsRunning(MultiXactId multi, 
*** 592,598 ****
  	{
  		if (TransactionIdIsInProgress(members[i].xid))
  		{
! 			debug_elog4(DEBUG2, "IsRunning: member %d (%u) is running",
  						i, members[i].xid);
  			pfree(members);
  			return true;
--- 558,564 ----
  	{
  		if (TransactionIdIsInProgress(members[i].xid))
  		{
! 			debug_elog4(DEBUG2, "IsRunning: member %d (" XID_FMT ") is running",
  						i, members[i].xid);
  			pfree(members);
  			return true;
*************** MultiXactIdIsRunning(MultiXactId multi, 
*** 601,607 ****
  
  	pfree(members);
  
! 	debug_elog3(DEBUG2, "IsRunning: %u is not running", multi);
  
  	return false;
  }
--- 567,573 ----
  
  	pfree(members);
  
! 	debug_elog3(DEBUG2, "IsRunning: " XID_FMT " is not running", multi);
  
  	return false;
  }
*************** MultiXactIdSetOldestMember(void)
*** 655,661 ****
  
  		LWLockRelease(MultiXactGenLock);
  
! 		debug_elog4(DEBUG2, "MultiXact: setting OldestMember[%d] = %u",
  					MyBackendId, nextMXact);
  	}
  }
--- 621,627 ----
  
  		LWLockRelease(MultiXactGenLock);
  
! 		debug_elog4(DEBUG2, "MultiXact: setting OldestMember[%d] = " XID_FMT,
  					MyBackendId, nextMXact);
  	}
  }
*************** MultiXactIdSetOldestVisible(void)
*** 708,714 ****
  
  		LWLockRelease(MultiXactGenLock);
  
! 		debug_elog4(DEBUG2, "MultiXact: setting OldestVisible[%d] = %u",
  					MyBackendId, oldestMXact);
  	}
  }
--- 674,680 ----
  
  		LWLockRelease(MultiXactGenLock);
  
! 		debug_elog4(DEBUG2, "MultiXact: setting OldestVisible[%d] = " XID_FMT,
  					MyBackendId, oldestMXact);
  	}
  }
*************** ReadNextMultiXactId(void)
*** 727,735 ****
  	mxid = MultiXactState->nextMXact;
  	LWLockRelease(MultiXactGenLock);
  
- 	if (mxid < FirstMultiXactId)
- 		mxid = FirstMultiXactId;
- 
  	return mxid;
  }
  
--- 693,698 ----
*************** static void
*** 841,848 ****
  RecordNewMultiXact(MultiXactId multi, MultiXactOffset offset,
  				   int nmembers, MultiXactMember *members)
  {
! 	int			pageno;
! 	int			prev_pageno;
  	int			entryno;
  	int			slotno;
  	MultiXactOffset *offptr;
--- 804,811 ----
  RecordNewMultiXact(MultiXactId multi, MultiXactOffset offset,
  				   int nmembers, MultiXactMember *members)
  {
! 	int64		pageno;
! 	int64		prev_pageno;
  	int			entryno;
  	int			slotno;
  	MultiXactOffset *offptr;
*************** RecordNewMultiXact(MultiXactId multi, Mu
*** 878,885 ****
  	for (i = 0; i < nmembers; i++, offset++)
  	{
  		TransactionId *memberptr;
! 		uint32	   *flagsptr;
! 		uint32		flagsval;
  		int			bshift;
  		int			flagsoff;
  		int			memberoff;
--- 841,848 ----
  	for (i = 0; i < nmembers; i++, offset++)
  	{
  		TransactionId *memberptr;
! 		uint64	   *flagsptr;
! 		uint64		flagsval;
  		int			bshift;
  		int			flagsoff;
  		int			memberoff;
*************** RecordNewMultiXact(MultiXactId multi, Mu
*** 900,913 ****
  		memberptr = (TransactionId *)
  			(MultiXactMemberCtl->shared->page_buffer[slotno] + memberoff);
  
  		*memberptr = members[i].xid;
  
! 		flagsptr = (uint32 *)
  			(MultiXactMemberCtl->shared->page_buffer[slotno] + flagsoff);
  
  		flagsval = *flagsptr;
! 		flagsval &= ~(((1 << MXACT_MEMBER_BITS_PER_XACT) - 1) << bshift);
! 		flagsval |= (members[i].status << bshift);
  		*flagsptr = flagsval;
  
  		MultiXactMemberCtl->shared->page_dirty[slotno] = true;
--- 863,877 ----
  		memberptr = (TransactionId *)
  			(MultiXactMemberCtl->shared->page_buffer[slotno] + memberoff);
  
+ 
  		*memberptr = members[i].xid;
  
! 		flagsptr = (uint64 *)
  			(MultiXactMemberCtl->shared->page_buffer[slotno] + flagsoff);
  
  		flagsval = *flagsptr;
! 		flagsval &= ~((uint64)((1 << MXACT_MEMBER_BITS_PER_XACT) - 1) << bshift);
! 		flagsval |= ((uint64)members[i].status << bshift);
  		*flagsptr = flagsval;
  
  		MultiXactMemberCtl->shared->page_dirty[slotno] = true;
*************** GetNewMultiXactId(int nmembers, MultiXac
*** 960,967 ****
  	 * If we're past multiVacLimit or the safe threshold for member storage
  	 * space, or we don't know what the safe threshold for member storage is,
  	 * start trying to force autovacuum cycles.
- 	 * If we're past multiWarnLimit, start issuing warnings.
- 	 * If we're past multiStopLimit, refuse to create new MultiXactIds.
  	 *
  	 * Note these are pretty much the same protections in GetNewTransactionId.
  	 *----------
--- 924,929 ----
*************** GetNewMultiXactId(int nmembers, MultiXac
*** 975,1015 ****
  		 * possibility of deadlock while doing get_database_name(). First,
  		 * copy all the shared values we'll need in this path.
  		 */
- 		MultiXactId multiWarnLimit = MultiXactState->multiWarnLimit;
- 		MultiXactId multiStopLimit = MultiXactState->multiStopLimit;
- 		MultiXactId multiWrapLimit = MultiXactState->multiWrapLimit;
- 		Oid			oldest_datoid = MultiXactState->oldestMultiXactDB;
- 
  		LWLockRelease(MultiXactGenLock);
  
- 		if (IsUnderPostmaster &&
- 			!MultiXactIdPrecedes(result, multiStopLimit))
- 		{
- 			char	   *oldest_datname = get_database_name(oldest_datoid);
- 
- 			/*
- 			 * Immediately kick autovacuum into action as we're already in
- 			 * ERROR territory.
- 			 */
- 			SendPostmasterSignal(PMSIGNAL_START_AUTOVAC_LAUNCHER);
- 
- 			/* complain even if that DB has disappeared */
- 			if (oldest_datname)
- 				ereport(ERROR,
- 						(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
- 						 errmsg("database is not accepting commands that generate new MultiXactIds to avoid wraparound data loss in database \"%s\"",
- 								oldest_datname),
- 				 errhint("Execute a database-wide VACUUM in that database.\n"
- 						 "You might also need to commit or roll back old prepared transactions.")));
- 			else
- 				ereport(ERROR,
- 						(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
- 						 errmsg("database is not accepting commands that generate new MultiXactIds to avoid wraparound data loss in database with OID %u",
- 								oldest_datoid),
- 				 errhint("Execute a database-wide VACUUM in that database.\n"
- 						 "You might also need to commit or roll back old prepared transactions.")));
- 		}
- 
  		/*
  		 * To avoid swamping the postmaster with signals, we issue the autovac
  		 * request only once per 64K multis generated.  This still gives
--- 937,944 ----
*************** GetNewMultiXactId(int nmembers, MultiXac
*** 1018,1053 ****
  		if (IsUnderPostmaster && (result % 65536) == 0)
  			SendPostmasterSignal(PMSIGNAL_START_AUTOVAC_LAUNCHER);
  
- 		if (!MultiXactIdPrecedes(result, multiWarnLimit))
- 		{
- 			char	   *oldest_datname = get_database_name(oldest_datoid);
- 
- 			/* complain even if that DB has disappeared */
- 			if (oldest_datname)
- 				ereport(WARNING,
- 						(errmsg_plural("database \"%s\" must be vacuumed before %u more MultiXactId is used",
- 									   "database \"%s\" must be vacuumed before %u more MultiXactIds are used",
- 									   multiWrapLimit - result,
- 									   oldest_datname,
- 									   multiWrapLimit - result),
- 				 errhint("Execute a database-wide VACUUM in that database.\n"
- 						 "You might also need to commit or roll back old prepared transactions.")));
- 			else
- 				ereport(WARNING,
- 						(errmsg_plural("database with OID %u must be vacuumed before %u more MultiXactId is used",
- 									   "database with OID %u must be vacuumed before %u more MultiXactIds are used",
- 									   multiWrapLimit - result,
- 									   oldest_datoid,
- 									   multiWrapLimit - result),
- 				 errhint("Execute a database-wide VACUUM in that database.\n"
- 						 "You might also need to commit or roll back old prepared transactions.")));
- 		}
- 
  		/* Re-acquire lock and start over */
  		LWLockAcquire(MultiXactGenLock, LW_EXCLUSIVE);
  		result = MultiXactState->nextMXact;
- 		if (result < FirstMultiXactId)
- 			result = FirstMultiXactId;
  	}
  
  	/* Make sure there is room for the MXID in the file.  */
--- 947,955 ----
*************** GetNewMultiXactId(int nmembers, MultiXac
*** 1059,1143 ****
  	 * GetMultiXactIdMembers() for motivation.
  	 */
  	nextOffset = MultiXactState->nextOffset;
! 	if (nextOffset == 0)
! 	{
! 		*offset = 1;
! 		nmembers++;				/* allocate member slot 0 too */
! 	}
! 	else
! 		*offset = nextOffset;
! 
! 	/*----------
! 	 * Protect against overrun of the members space as well, with the
! 	 * following rules:
! 	 *
! 	 * If we're past offsetStopLimit, refuse to generate more multis.
! 	 * If we're close to offsetStopLimit, emit a warning.
! 	 *
! 	 * Arbitrarily, we start emitting warnings when we're 20 segments or less
! 	 * from offsetStopLimit.
! 	 *
! 	 * Note we haven't updated the shared state yet, so if we fail at this
! 	 * point, the multixact ID we grabbed can still be used by the next guy.
! 	 *
! 	 * Note that there is no point in forcing autovacuum runs here: the
! 	 * multixact freeze settings would have to be reduced for that to have any
! 	 * effect.
! 	 *----------
! 	 */
! #define OFFSET_WARN_SEGMENTS	20
! 	if (MultiXactState->oldestOffsetKnown &&
! 		MultiXactOffsetWouldWrap(MultiXactState->offsetStopLimit, nextOffset,
! 								 nmembers))
! 	{
! 		/* see comment in the corresponding offsets wraparound case */
! 		SendPostmasterSignal(PMSIGNAL_START_AUTOVAC_LAUNCHER);
! 
! 		ereport(ERROR,
! 				(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
! 				 errmsg("multixact \"members\" limit exceeded"),
! 				 errdetail_plural("This command would create a multixact with %u members, but the remaining space is only enough for %u member.",
! 								  "This command would create a multixact with %u members, but the remaining space is only enough for %u members.",
! 							MultiXactState->offsetStopLimit - nextOffset - 1,
! 								  nmembers,
! 						   MultiXactState->offsetStopLimit - nextOffset - 1),
! 				 errhint("Execute a database-wide VACUUM in database with OID %u with reduced vacuum_multixact_freeze_min_age and vacuum_multixact_freeze_table_age settings.",
! 						 MultiXactState->oldestMultiXactDB)));
! 	}
! 
! 	/*
! 	 * Check whether we should kick autovacuum into action, to prevent members
! 	 * wraparound. NB we use a much larger window to trigger autovacuum than
! 	 * just the warning limit. The warning is just a measure of last resort -
! 	 * this is in line with GetNewTransactionId's behaviour.
! 	 */
! 	if (!MultiXactState->oldestOffsetKnown ||
! 		(MultiXactState->nextOffset - MultiXactState->oldestOffset
! 		 > MULTIXACT_MEMBER_SAFE_THRESHOLD))
! 	{
! 		/*
! 		 * To avoid swamping the postmaster with signals, we issue the autovac
! 		 * request only when crossing a segment boundary. With default
! 		 * compilation settings that's roughly after 50k members.  This still
! 		 * gives plenty of chances before we get into real trouble.
! 		 */
! 		if ((MXOffsetToMemberPage(nextOffset) / SLRU_PAGES_PER_SEGMENT) !=
! 			(MXOffsetToMemberPage(nextOffset + nmembers) / SLRU_PAGES_PER_SEGMENT))
! 			SendPostmasterSignal(PMSIGNAL_START_AUTOVAC_LAUNCHER);
! 	}
! 
! 	if (MultiXactState->oldestOffsetKnown &&
! 		MultiXactOffsetWouldWrap(MultiXactState->offsetStopLimit,
! 								 nextOffset,
! 								 nmembers + MULTIXACT_MEMBERS_PER_PAGE * SLRU_PAGES_PER_SEGMENT * OFFSET_WARN_SEGMENTS))
! 		ereport(WARNING,
! 				(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
! 				 errmsg_plural("database with OID %u must be vacuumed before %d more multixact member is used",
! 							   "database with OID %u must be vacuumed before %d more multixact members are used",
! 					 MultiXactState->offsetStopLimit - nextOffset + nmembers,
! 							   MultiXactState->oldestMultiXactDB,
! 					MultiXactState->offsetStopLimit - nextOffset + nmembers),
! 				 errhint("Execute a database-wide VACUUM in that database with reduced vacuum_multixact_freeze_min_age and vacuum_multixact_freeze_table_age settings.")));
  
  	ExtendMultiXactMember(nextOffset, nmembers);
  
--- 961,967 ----
  	 * GetMultiXactIdMembers() for motivation.
  	 */
  	nextOffset = MultiXactState->nextOffset;
! 	*offset = nextOffset;
  
  	ExtendMultiXactMember(nextOffset, nmembers);
  
*************** GetNewMultiXactId(int nmembers, MultiXac
*** 1167,1173 ****
  
  	LWLockRelease(MultiXactGenLock);
  
! 	debug_elog4(DEBUG2, "GetNew: returning %u offset %u", result, *offset);
  	return result;
  }
  
--- 991,997 ----
  
  	LWLockRelease(MultiXactGenLock);
  
! 	debug_elog4(DEBUG2, "GetNew: returning " XID_FMT " offset " INT64_FORMAT, result, *offset);
  	return result;
  }
  
*************** int
*** 1202,1209 ****
  GetMultiXactIdMembers(MultiXactId multi, MultiXactMember **members,
  					  bool from_pgupgrade, bool onlyLock)
  {
! 	int			pageno;
! 	int			prev_pageno;
  	int			entryno;
  	int			slotno;
  	MultiXactOffset *offptr;
--- 1026,1033 ----
  GetMultiXactIdMembers(MultiXactId multi, MultiXactMember **members,
  					  bool from_pgupgrade, bool onlyLock)
  {
! 	int64		pageno;
! 	int64		prev_pageno;
  	int			entryno;
  	int			slotno;
  	MultiXactOffset *offptr;
*************** GetMultiXactIdMembers(MultiXactId multi,
*** 1211,1223 ****
  	int			length;
  	int			truelength;
  	int			i;
- 	MultiXactId oldestMXact;
  	MultiXactId nextMXact;
  	MultiXactId tmpMXact;
  	MultiXactOffset nextOffset;
  	MultiXactMember *ptr;
  
! 	debug_elog3(DEBUG2, "GetMembers: asked for %u", multi);
  
  	if (!MultiXactIdIsValid(multi) || from_pgupgrade)
  		return -1;
--- 1035,1046 ----
  	int			length;
  	int			truelength;
  	int			i;
  	MultiXactId nextMXact;
  	MultiXactId tmpMXact;
  	MultiXactOffset nextOffset;
  	MultiXactMember *ptr;
  
! 	debug_elog3(DEBUG2, "GetMembers: asked for " XID_FMT, multi);
  
  	if (!MultiXactIdIsValid(multi) || from_pgupgrade)
  		return -1;
*************** GetMultiXactIdMembers(MultiXactId multi,
*** 1264,1290 ****
  	 */
  	LWLockAcquire(MultiXactGenLock, LW_SHARED);
  
- 	oldestMXact = MultiXactState->oldestMultiXactId;
  	nextMXact = MultiXactState->nextMXact;
  	nextOffset = MultiXactState->nextOffset;
  
  	LWLockRelease(MultiXactGenLock);
  
- 	if (MultiXactIdPrecedes(multi, oldestMXact))
- 	{
- 		ereport(ERROR,
- 				(errcode(ERRCODE_INTERNAL_ERROR),
- 		 errmsg("MultiXactId %u does no longer exist -- apparent wraparound",
- 				multi)));
- 		return -1;
- 	}
- 
- 	if (!MultiXactIdPrecedes(multi, nextMXact))
- 		ereport(ERROR,
- 				(errcode(ERRCODE_INTERNAL_ERROR),
- 				 errmsg("MultiXactId %u has not been created yet -- apparent wraparound",
- 						multi)));
- 
  	/*
  	 * Find out the offset at which we need to start reading MultiXactMembers
  	 * and the number of members in the multixact.  We determine the latter as
--- 1087,1097 ----
*************** retry:
*** 1346,1355 ****
  	{
  		MultiXactOffset nextMXOffset;
  
- 		/* handle wraparound if needed */
- 		if (tmpMXact < FirstMultiXactId)
- 			tmpMXact = FirstMultiXactId;
- 
  		prev_pageno = pageno;
  
  		pageno = MultiXactIdToOffsetPage(tmpMXact);
--- 1153,1158 ----
*************** retry:
*** 1387,1393 ****
  	for (i = 0; i < length; i++, offset++)
  	{
  		TransactionId *xactptr;
! 		uint32	   *flagsptr;
  		int			flagsoff;
  		int			bshift;
  		int			memberoff;
--- 1190,1196 ----
  	for (i = 0; i < length; i++, offset++)
  	{
  		TransactionId *xactptr;
! 		uint64	   *flagsptr;
  		int			flagsoff;
  		int			bshift;
  		int			memberoff;
*************** retry:
*** 1413,1419 ****
  
  		flagsoff = MXOffsetToFlagsOffset(offset);
  		bshift = MXOffsetToFlagsBitShift(offset);
! 		flagsptr = (uint32 *) (MultiXactMemberCtl->shared->page_buffer[slotno] + flagsoff);
  
  		ptr[truelength].xid = *xactptr;
  		ptr[truelength].status = (*flagsptr >> bshift) & MXACT_MEMBER_XACT_BITMASK;
--- 1216,1222 ----
  
  		flagsoff = MXOffsetToFlagsOffset(offset);
  		bshift = MXOffsetToFlagsBitShift(offset);
! 		flagsptr = (uint64 *) (MultiXactMemberCtl->shared->page_buffer[slotno] + flagsoff);
  
  		ptr[truelength].xid = *xactptr;
  		ptr[truelength].status = (*flagsptr >> bshift) & MXACT_MEMBER_XACT_BITMASK;
*************** mXactCacheGetBySet(int nmembers, MultiXa
*** 1493,1499 ****
  		 */
  		if (memcmp(members, entry->members, nmembers * sizeof(MultiXactMember)) == 0)
  		{
! 			debug_elog3(DEBUG2, "CacheGet: found %u", entry->multi);
  			dlist_move_head(&MXactCache, iter.cur);
  			return entry->multi;
  		}
--- 1296,1302 ----
  		 */
  		if (memcmp(members, entry->members, nmembers * sizeof(MultiXactMember)) == 0)
  		{
! 			debug_elog3(DEBUG2, "CacheGet: found " XID_FMT, entry->multi);
  			dlist_move_head(&MXactCache, iter.cur);
  			return entry->multi;
  		}
*************** mXactCacheGetById(MultiXactId multi, Mul
*** 1516,1522 ****
  {
  	dlist_iter	iter;
  
! 	debug_elog3(DEBUG2, "CacheGet: looking for %u", multi);
  
  	dlist_foreach(iter, &MXactCache)
  	{
--- 1319,1325 ----
  {
  	dlist_iter	iter;
  
! 	debug_elog3(DEBUG2, "CacheGet: looking for " XID_FMT, multi);
  
  	dlist_foreach(iter, &MXactCache)
  	{
*************** mXactCachePut(MultiXactId multi, int nme
*** 1597,1603 ****
  		MXactCacheMembers--;
  
  		entry = dlist_container(mXactCacheEnt, node, node);
! 		debug_elog3(DEBUG2, "CachePut: pruning cached multi %u",
  					entry->multi);
  
  		pfree(entry);
--- 1400,1406 ----
  		MXactCacheMembers--;
  
  		entry = dlist_container(mXactCacheEnt, node, node);
! 		debug_elog3(DEBUG2, "CachePut: pruning cached multi " XID_FMT,
  					entry->multi);
  
  		pfree(entry);
*************** mxid_to_string(MultiXactId multi, int nm
*** 1639,1649 ****
  
  	initStringInfo(&buf);
  
! 	appendStringInfo(&buf, "%u %d[%u (%s)", multi, nmembers, members[0].xid,
  					 mxstatus_to_string(members[0].status));
  
  	for (i = 1; i < nmembers; i++)
! 		appendStringInfo(&buf, ", %u (%s)", members[i].xid,
  						 mxstatus_to_string(members[i].status));
  
  	appendStringInfoChar(&buf, ']');
--- 1442,1452 ----
  
  	initStringInfo(&buf);
  
! 	appendStringInfo(&buf, XID_FMT " %d[" XID_FMT " (%s)", multi, nmembers, members[0].xid,
  					 mxstatus_to_string(members[0].status));
  
  	for (i = 1; i < nmembers; i++)
! 		appendStringInfo(&buf, ", " XID_FMT " (%s)", members[i].xid,
  						 mxstatus_to_string(members[i].status));
  
  	appendStringInfoChar(&buf, ']');
*************** MultiXactShmemInit(void)
*** 1823,1831 ****
  
  	debug_elog2(DEBUG2, "Shared Memory Init for MultiXact");
  
- 	MultiXactOffsetCtl->PagePrecedes = MultiXactOffsetPagePrecedes;
- 	MultiXactMemberCtl->PagePrecedes = MultiXactMemberPagePrecedes;
- 
  	SimpleLruInit(MultiXactOffsetCtl,
  				  "multixact_offset", NUM_MXACTOFFSET_BUFFERS, 0,
  				  MultiXactOffsetControlLock, "pg_multixact/offsets",
--- 1626,1631 ----
*************** BootStrapMultiXact(void)
*** 1900,1906 ****
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! ZeroMultiXactOffsetPage(int pageno, bool writeXlog)
  {
  	int			slotno;
  
--- 1700,1706 ----
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! ZeroMultiXactOffsetPage(int64 pageno, bool writeXlog)
  {
  	int			slotno;
  
*************** ZeroMultiXactOffsetPage(int pageno, bool
*** 1916,1922 ****
   * Ditto, for MultiXactMember
   */
  static int
! ZeroMultiXactMemberPage(int pageno, bool writeXlog)
  {
  	int			slotno;
  
--- 1716,1722 ----
   * Ditto, for MultiXactMember
   */
  static int
! ZeroMultiXactMemberPage(int64 pageno, bool writeXlog)
  {
  	int			slotno;
  
*************** ZeroMultiXactMemberPage(int pageno, bool
*** 1946,1952 ****
  static void
  MaybeExtendOffsetSlru(void)
  {
! 	int			pageno;
  
  	pageno = MultiXactIdToOffsetPage(MultiXactState->nextMXact);
  
--- 1746,1752 ----
  static void
  MaybeExtendOffsetSlru(void)
  {
! 	int64		pageno;
  
  	pageno = MultiXactIdToOffsetPage(MultiXactState->nextMXact);
  
*************** StartupMultiXact(void)
*** 1981,1987 ****
  {
  	MultiXactId multi = MultiXactState->nextMXact;
  	MultiXactOffset offset = MultiXactState->nextOffset;
! 	int			pageno;
  
  	/*
  	 * Initialize offset's idea of the latest page number.
--- 1781,1787 ----
  {
  	MultiXactId multi = MultiXactState->nextMXact;
  	MultiXactOffset offset = MultiXactState->nextOffset;
! 	int64		pageno;
  
  	/*
  	 * Initialize offset's idea of the latest page number.
*************** TrimMultiXact(void)
*** 2006,2012 ****
  	MultiXactOffset offset;
  	MultiXactId oldestMXact;
  	Oid			oldestMXactDB;
! 	int			pageno;
  	int			entryno;
  	int			flagsoff;
  
--- 1806,1812 ----
  	MultiXactOffset offset;
  	MultiXactId oldestMXact;
  	Oid			oldestMXactDB;
! 	int64		pageno;
  	int			entryno;
  	int			flagsoff;
  
*************** MultiXactGetCheckptMulti(bool is_shutdow
*** 2129,2135 ****
  	LWLockRelease(MultiXactGenLock);
  
  	debug_elog6(DEBUG2,
! 				"MultiXact: checkpoint is nextMulti %u, nextOffset %u, oldestMulti %u in DB %u",
  				*nextMulti, *nextMultiOffset, *oldestMulti, *oldestMultiDB);
  }
  
--- 1929,1935 ----
  	LWLockRelease(MultiXactGenLock);
  
  	debug_elog6(DEBUG2,
! 				"MultiXact: checkpoint is nextMulti " XID_FMT ", nextOffset " INT64_FORMAT ", oldestMulti " XID_FMT " in DB %u",
  				*nextMulti, *nextMultiOffset, *oldestMulti, *oldestMultiDB);
  }
  
*************** void
*** 2160,2166 ****
  MultiXactSetNextMXact(MultiXactId nextMulti,
  					  MultiXactOffset nextMultiOffset)
  {
! 	debug_elog4(DEBUG2, "MultiXact: setting next multi to %u offset %u",
  				nextMulti, nextMultiOffset);
  	LWLockAcquire(MultiXactGenLock, LW_EXCLUSIVE);
  	MultiXactState->nextMXact = nextMulti;
--- 1960,1966 ----
  MultiXactSetNextMXact(MultiXactId nextMulti,
  					  MultiXactOffset nextMultiOffset)
  {
! 	debug_elog4(DEBUG2, "MultiXact: setting next multi to " XID_FMT " offset " INT64_FORMAT,
  				nextMulti, nextMultiOffset);
  	LWLockAcquire(MultiXactGenLock, LW_EXCLUSIVE);
  	MultiXactState->nextMXact = nextMulti;
